> For the complete documentation index, see [llms.txt](https://docs.caf.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.caf.io/caf-sdk/ios/standalone-modules/caffaceliveness/builder.md).

# Building the SDK

## Creating a Liveness SDK instance

In order to create an instance of `CafFaceLivenessSDK`, we need to use our `CafFaceLivenessBuilder`. This allows you to configure all necessary configurations.

### Builder Methods

| Parameter                           | Required | Description                                                                                   |
| ----------------------------------- | -------- | --------------------------------------------------------------------------------------------- |
| `setStage(CAFStage)`                | No       | Defines the environment stage (e.g., `.prod`, `.beta`). Default is `.prod`.                   |
| `setImageUrlExpirationTime(String)` | No       | Sets the expiration time for the image URL used in the scan capture. Default is `"3H"`.       |
| `setLoadingScreen(Bool)`            | No       | Enables or disables the default loading screen during SDK loading events. Default is `false`. |
| `delegate = self`                   | Yes      | Sets the delegate to handle liveness verification events.                                     |

### Example

```swift
    private var sdk: CafFaceLivenessSDK?

private func setupCafFaceLiveness() {
    sdk = CafFaceLivenessSDK.CafFaceLivenessBuilder()
        .setStage(.prod)
        .setImageUrlExpirationTime("2H")
        .setLoadingScreen(withLoading: true)
        .build()
    
    sdk?.delegate = self
    sdk?.startSDK(viewController: self, mobileToken: "your_mobile_token", personId: "your_person_id")
}

// MARK: - CafFaceLivenessDelegate

extension YourViewController: CafFaceLivenessDelegate {
    func didFinishWithSuccess(livenessResult: CafLivenessResult) {
        print("Success: \(livenessResult.signedResponse ?? "No response")")
    }

    func cancelled() {
        print("Liveness detection cancelled")
    }

    func didFinishWithError(sdkFailure: CafSDKFailure) {
        print("Error: \(sdkFailure.description ?? "Unknown error")")
    }

    func loading() {
        print("Liveness detection loading")
    }

    func loaded() {
        print("Liveness detection loaded")
    }
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.caf.io/caf-sdk/ios/standalone-modules/caffaceliveness/builder.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
